{-# OPTIONS -fglasgow-exts #-}

import CpsYield
import Monad


data Tree a = Leaf a | Node (Tree a) (Tree a)
            deriving Show

depthWalk :: Tree a -> Yield b a (Tree b)
depthWalk (Node l r) =  do l' <- depthWalk l
                           r' <- depthWalk r     
                           return (Node l' r')
depthWalk (Leaf a)   =  do b <- yield a
                           return (Leaf b)


renum (Susp n k) = renum (k (n+1))
renum (Result t) = t

loop :: (o -> i) -> Yield i o r -> r
loop f m = each (run m) 
    where
      each (Susp v k) = each (k (f v))
      each (Result r) = r 

renum0 = loop (\n -> n + 1)

same :: Eq a => Iterator a a b -> Iterator a a b ->  Bool
same (Result _) (Result _)              = True
same (Susp a ka) (Susp b kb) | (a == b) = same (ka a) (kb b)
same _ _                                = False

swap ::Iterator a a b -> Iterator a a b ->  (b, b)
swap (Susp a ka) (Susp b kb) = swap (ka b) (kb a)
swap (Result t1') (Result t2') = (t1', t2')
swap _ _ = error "Unequal number of leaves"
