-- Roshan P. James, Amr Sabry
-- rpjames@cs.indiana.edu, sabry@cs.indiana.edu

import CpsYield


type SR ans r = Yield In (Out ans) r
data In a = In { unIn :: a }
data Out ans a = Out ((a -> ans) -> SR ans ans)

shift :: ((a -> ans) -> SR ans ans) -> SR ans a
shift e = (yield (Out e)) >>= (return . unIn)

reset :: SR ans ans -> ans
reset e = interp (run e)
     where 
       interp (Susp (Out f) k) = reset $ f $ \i -> interp (k (In i))
       interp (Result r) = r


------------------------------------------------------
-- Ex.
--
-- Captures two continuations of different input types:
-- Int -> Int 
-- Bool -> Int
-- Answer type is fixed to Int. 
test = reset $ 
       do num <- shift (\add1 -> 
                            do flag <- shift (\toNum -> 
                                                  return (add1 (toNum True)))
                               if flag 
                                 then return 1
                                 else return 0);
                 return (num+1)
                         